##Parity 2 processing (UKHLS-only)
betadim <- ncol(B_A2)+ncol(B_C2)+ncol(B_T2)+ncol(B_AC4)
Yhat <- extract(stanout,pars="Y_hat",permuted=F)
Yhatm2 <- apply(inv.logit(Yhat[,1,]),2,mean)
beta0 <- extract(stanout,pars="beta0",permuted=F)
betaQ <- extract(stanout,pars="betaQ",permuted=F)
beta <- extract(stanout,pars="beta",permuted=F)
XB <- B_A2[A_ind,]%*%t(beta[,1,1:8])
Adat2 <- data.frame(parity=p,cov=agerange,fit=apply(XB,1,mean),lower=apply(XB,1,quantile,p=0.025),upper=apply(XB,1,quantile,p=0.975))
XB <- B_C2all[C_indall,]%*%t(beta[,1,9:16])
Cdat2 <- data.frame(parity=p,cov=cohrange,fit=apply(XB,1,mean),lower=apply(XB,1,quantile,p=0.025),upper=apply(XB,1,quantile,p=0.975))
XB <- B_T2[T_ind,]%*%t(beta[,1,17:24])
Tdat2 <- data.frame(parity=p,cov=1:11,fit=apply(XB,1,mean),lower=apply(XB,1,quantile,p=0.025),upper=apply(XB,1,quantile,p=0.975))
XB <- list()
for (i in 1:1000)
  XB[[i]] <- matrix(rep(B_A2[A_ind,]%*%beta[i,1,1:8],length(cohrange)),nrow=length(agerange),byrow=F)+
  matrix(rep(B_C2all[C_indall,]%*%beta[i,1,9:16],length(agerange)),nrow=length(agerange),byrow=T)+
  matrix(B_ACfull3[,-ind]%*%beta[i,1,25:betadim],nrow=length(agerange),byrow=F)
XBl <- XBu <- XB[[1]]
for (i in 1:length(agerange)) {
  for (j in 1:length(cohrange)) {
    tmp <- numeric()
    for (k in 1:1000) tmp[k] <- XB[[k]][i,j]
    XBl[i,j] <- quantile(tmp,p=0.025)
    XBu[i,j] <- quantile(tmp,p=0.975)
  }
}
XBm <- Reduce("+",XB)/1000
ACACdat2 <- data.frame(parity=p,age=rep(agerange,length(cohrange)),
                       coh=rep(cohrange,each=length(agerange)),
                       fit=as.vector(XBm),
                       lower=as.vector(XBl),
                       upper=as.vector(XBu))
XB <- B_ACfull3[,-ind]%*%t(beta[,1,25:betadim])
ACdat2 <- data.frame(parity=p,age=rep(agerange,length(cohrange)),
                     coh=rep(cohrange,each=length(agerange)),
                     fit=apply(XB,1,mean),
                     lower=apply(XB,1,quantile,p=0.025),
                     upper=apply(XB,1,quantile,p=0.975))
wt2 <- data2w$nw/data2w$n
fdat2 <- data.frame(parity=p,age=data2$age_2[wt2>0],
                    coh=data2$coh_2[wt2>0],
                    gapc=data2$gapc_2[wt2>0],
                    qualf=data2$qualf3bimp_2[wt2>0],
                    stan=Yhatm2[wt2>0])
probfit1 <- probfit2 <- probfit3 <- list()
for (t in 1:11) {
  probfit1[[t]] <- probfit2[[t]] <- probfit3[[t]] <- list()
  for (i in 1:1000) {
    probfit1[[t]][[i]] <- inv.logit(matrix(rep(beta0[i,1,1],length(cohrange)*length(agerange)),nrow=length(agerange))+
                                      matrix(rep(B_A2[A_ind,]%*%beta[i,1,1:8],length(cohrange)),nrow=length(agerange),byrow=F)+
                                      matrix(rep(B_C2all[C_indall,]%*%beta[i,1,9:16],length(agerange)),nrow=length(agerange),byrow=T)+
                                      matrix(rep(B_T2[T_ind[t],]%*%beta[i,1,17:24],length(cohrange)*length(agerange)),nrow=length(agerange))+
                                      matrix(B_ACfull3[,-ind]%*%beta[i,1,25:betadim],nrow=length(agerange),byrow=F))
    probfit2[[t]][[i]] <- inv.logit(matrix(rep(beta0[i,1,1],length(cohrange)*length(agerange)),nrow=length(agerange))+
                                      matrix(rep(betaQ[i,1,2],length(cohrange)*length(agerange)),nrow=length(agerange))+
                                      matrix(rep(B_A2[A_ind,]%*%beta[i,1,1:8],length(cohrange)),nrow=length(agerange),byrow=F)+
                                      matrix(rep(B_C2all[C_indall,]%*%beta[i,1,9:16],length(agerange)),nrow=length(agerange),byrow=T)+
                                      matrix(rep(B_T2[T_ind[t],]%*%beta[i,1,17:24],length(cohrange)*length(agerange)),nrow=length(agerange))+
                                      matrix(B_ACfull3[,-ind]%*%beta[i,1,25:betadim],nrow=length(agerange),byrow=F))
    probfit3[[t]][[i]] <- inv.logit(matrix(rep(beta0[i,1,1],length(cohrange)*length(agerange)),nrow=length(agerange))+
                                      matrix(rep(betaQ[i,1,3],length(cohrange)*length(agerange)),nrow=length(agerange))+
                                      matrix(rep(B_A2[A_ind,]%*%beta[i,1,1:8],length(cohrange)),nrow=length(agerange),byrow=F)+
                                      matrix(rep(B_C2all[C_indall,]%*%beta[i,1,9:16],length(agerange)),nrow=length(agerange),byrow=T)+
                                      matrix(rep(B_T2[T_ind[t],]%*%beta[i,1,17:24],length(cohrange)*length(agerange)),nrow=length(agerange))+
                                      matrix(B_ACfull3[,-ind]%*%beta[i,1,25:betadim],nrow=length(agerange),byrow=F))
  }
}
probfitm1 <- probfitm2 <- probfitm3 <- list()
for (t in 1:11) {
  probfitm1[[t]] <- Reduce("+",probfit1[[t]])/1000
  probfitm2[[t]] <- Reduce("+",probfit2[[t]])/1000
  probfitm3[[t]] <- Reduce("+",probfit3[[t]])/1000
}
probfitlw1 <- probfitlw2 <- probfitlw3 <- probfitup1 <- probfitup2 <- probfitup3 <- probfitm1
for (t in 1:11) {
  for (i in 1:length(agerange)) {
    for (j in 1:length(cohrange)) {
      tmp1 <- tmp2 <- tmp3 <- numeric()
      for (k in 1:1000) {
        tmp1[k] <- probfit1[[t]][[k]][i,j]
        tmp2[k] <- probfit2[[t]][[k]][i,j]
        tmp3[k] <- probfit3[[t]][[k]][i,j]
      }
      probfitlw1[[t]][i,j] <- quantile(tmp1,p=0.025)
      probfitlw2[[t]][i,j] <- quantile(tmp2,p=0.025)
      probfitlw3[[t]][i,j] <- quantile(tmp3,p=0.025)
      probfitup1[[t]][i,j] <- quantile(tmp1,p=0.975)
      probfitup2[[t]][i,j] <- quantile(tmp2,p=0.975)
      probfitup3[[t]][i,j] <- quantile(tmp3,p=0.975)
    }
  }
}
probdat2 <- data.frame(parity=p,age=rep(rep(agerange,length(cohrange)),33),
                       coh=rep(rep(cohrange,each=length(agerange)),33),
                       gapc=rep(rep(1:11,each=length(agerange)*length(cohrange)),3),
                       qualf=rep(1:3,each=length(cohrange)*length(agerange)*11),
                       fit=c(as.vector(unlist(probfitm1)),as.vector(unlist(probfitm2)),as.vector(unlist(probfitm3))),
                       lower=c(as.vector(unlist(probfitlw1)),as.vector(unlist(probfitlw2)),as.vector(unlist(probfitlw3))),
                       upper=c(as.vector(unlist(probfitup1)),as.vector(unlist(probfitup2)),as.vector(unlist(probfitup3))))

#Extract results
results$Yhatm[[n]] <- Yhatm2
results$Adat[[n]] <- Adat2
results$Cdat[[n]] <- Cdat2
results$Tdat[[n]] <- Tdat2
results$ACACdat[[n]] <- ACACdat2
results$ACdat[[n]] <- ACdat2
results$fdat[[n]] <- fdat2
results$probdat[[n]] <- probdat2

#Marginalisation
data2f <- expand.grid(age=agerange,coh=cohrange,gapc=1:11,qualf=1:3)
Xf <- cbind(B_A2[A_ind[data2f$age-14],],
            B_C2all[C_indall[data2f$coh-1944],],
            B_T2[T_ind[data2f$gapc],],
            B_ACfull3[rep(1:nrow(B_ACfull3),33),-ind])
Nf <- nrow(data2f)
Nm <- length(agerange)*length(cohrange)
Afind <- c(data2f$age-14)[1:Nm]
ACind <- 1:nrow(B_ACfull3)
Xqf <- matrix(0,Nf,3)
for (q in 1:3) Xqf[,q] <- ifelse(data2f$qualf==q,1,0)

thetaf <- inv.logit(matrix(rep(beta0,Nf),ncol=1000,byrow=T)+
                      Xf%*%t(beta[,1,])+
                      Xqf%*%t(betaQ[,1,]))
psurvf <- matrix(0,1000,Nm)
for (j in 1:1000) {
  Tprop1j <- matrix(Tprop1[j,1,],ncol=11,byrow=F)
  Tprop2j <- matrix(Tprop2[j,1,],ncol=11,byrow=F)
  Tprop3j <- matrix(Tprop3[j,1,],ncol=11,byrow=F)
  thetaj <- matrix(theta[j,1,],ncol=3,byrow=F)
  for (i in 1:Nm) {
    psurvf[j,i] <- Tprop1j[Afind[i],1]*thetaj[ACind[i],1]*thetaf[i,j]+
      Tprop1j[Afind[i],2]*thetaj[ACind[i],1]*thetaf[Nm+i,j]+
      Tprop1j[Afind[i],3]*thetaj[ACind[i],1]*thetaf[2*Nm+i,j]+
      Tprop1j[Afind[i],4]*thetaj[ACind[i],1]*thetaf[3*Nm+i,j]+
      Tprop1j[Afind[i],5]*thetaj[ACind[i],1]*thetaf[4*Nm+i,j]+
      Tprop1j[Afind[i],6]*thetaj[ACind[i],1]*thetaf[5*Nm+i,j]+
      Tprop1j[Afind[i],7]*thetaj[ACind[i],1]*thetaf[6*Nm+i,j]+
      Tprop1j[Afind[i],8]*thetaj[ACind[i],1]*thetaf[7*Nm+i,j]+
      Tprop1j[Afind[i],9]*thetaj[ACind[i],1]*thetaf[8*Nm+i,j]+
      Tprop1j[Afind[i],10]*thetaj[ACind[i],1]*thetaf[9*Nm+i,j]+
      Tprop1j[Afind[i],11]*thetaj[ACind[i],1]*thetaf[10*Nm+i,j]+
      Tprop2j[Afind[i],1]*thetaj[ACind[i],2]*thetaf[11*Nm+i,j]+
      Tprop2j[Afind[i],2]*thetaj[ACind[i],2]*thetaf[12*Nm+i,j]+
      Tprop2j[Afind[i],3]*thetaj[ACind[i],2]*thetaf[13*Nm+i,j]+
      Tprop2j[Afind[i],4]*thetaj[ACind[i],2]*thetaf[14*Nm+i,j]+
      Tprop2j[Afind[i],5]*thetaj[ACind[i],2]*thetaf[15*Nm+i,j]+
      Tprop2j[Afind[i],6]*thetaj[ACind[i],2]*thetaf[16*Nm+i,j]+
      Tprop2j[Afind[i],7]*thetaj[ACind[i],2]*thetaf[17*Nm+i,j]+
      Tprop2j[Afind[i],8]*thetaj[ACind[i],2]*thetaf[18*Nm+i,j]+
      Tprop2j[Afind[i],9]*thetaj[ACind[i],2]*thetaf[19*Nm+i,j]+
      Tprop2j[Afind[i],10]*thetaj[ACind[i],2]*thetaf[20*Nm+i,j]+
      Tprop2j[Afind[i],11]*thetaj[ACind[i],2]*thetaf[21*Nm+i,j]+
      Tprop3j[Afind[i],1]*thetaj[ACind[i],3]*thetaf[22*Nm+i,j]+
      Tprop3j[Afind[i],2]*thetaj[ACind[i],3]*thetaf[23*Nm+i,j]+
      Tprop3j[Afind[i],3]*thetaj[ACind[i],3]*thetaf[24*Nm+i,j]+
      Tprop3j[Afind[i],4]*thetaj[ACind[i],3]*thetaf[25*Nm+i,j]+
      Tprop3j[Afind[i],5]*thetaj[ACind[i],3]*thetaf[26*Nm+i,j]+
      Tprop3j[Afind[i],6]*thetaj[ACind[i],3]*thetaf[27*Nm+i,j]+
      Tprop3j[Afind[i],7]*thetaj[ACind[i],3]*thetaf[28*Nm+i,j]+
      Tprop3j[Afind[i],8]*thetaj[ACind[i],3]*thetaf[29*Nm+i,j]+
      Tprop3j[Afind[i],9]*thetaj[ACind[i],3]*thetaf[30*Nm+i,j]+
      Tprop3j[Afind[i],10]*thetaj[ACind[i],3]*thetaf[31*Nm+i,j]+
      Tprop3j[Afind[i],11]*thetaj[ACind[i],3]*thetaf[32*Nm+i,j]
  }
}
results$psurvf[[n]] <- psurvf
results$psurvfm[[n]] <- apply(psurvf,2,mean)
results$psurvfl[[n]] <- apply(psurvf,2,quantile,p=0.025)
results$psurvfu[[n]] <- apply(psurvf,2,quantile,p=0.975)
psumf <- apply(psurvf,1,function(x) aggregate(x,by=list(data2f$coh[1:Nm]),sum)$x)
results$psumfm[[n]] <- apply(psumf,1,mean)
results$psumfl[[n]] <- apply(psumf,1,quantile,p=0.025)
results$psumfu[[n]] <- apply(psumf,1,quantile,p=0.975)
wsumf <- apply(psurvf,1,function(x) aggregate(x,by=list(data2f$coh[1:Nm]),function(x) sum(15:44*x)/sum(x))$x)
results$wsumfm[[n]] <- apply(wsumf,1,mean)
results$wsumfl[[n]] <- apply(wsumf,1,quantile,p=0.025)
results$wsumfu[[n]] <- apply(wsumf,1,quantile,p=0.975)
